// http://bl.ocks.org/3687826

export const tabulate = (selection, props) => {
 		const {
      data, 
      columns,
      onTableRowMouseOver,
      onTableRowMouseLeave,
      resetAllChart
    } = props;
  // Add table in new div(s)
  	// var table = selection.data([null]);
  
    const tableEnter = selection.append('table');

    // Append table head in new table(s)
    var thead = tableEnter.append('thead')
      .append('tr')
        .selectAll('th')
        .data(columns);
  	thead
      .enter().append('th')
        .text(d => d); 

    // Append table body in new table(s)
    var tbody = tableEnter.append('tbody');

    // create a row for each object in the data
		var rows = tbody.selectAll('tr').data(data);
  	var rowsEnter = rows
    	.enter()
    		.append('tr')
    		// .on('mouseenter', onTableRowMouseOver)
    		// .on('mouseout', resetAllChart);
  
  	rows.exit().remove();
  	// rows.enter().append('tr');
  	
		// create a cell in each row for each column
		var cells = rowsEnter.selectAll('td')
		  .data(function (row) {
        // console.log(row);
		    return columns.map(function (column) {
		      return {column: column, value: row[column]};
		    });
		  });
  
  	//cells.exit().remove();
    cells.enter().append('td').text(function (d) { return d.value; });
		
	  // return table;
// 		var table = d3.select('#grid').append('table')
// 		var thead = table.append('thead')
// 		var	tbody = table.append('tbody');

// 		// append the header row
// 		thead.append('tr')
// 		  .selectAll('th')
// 		  .data(columns).enter()
// 		  .append('th')
// 		    .text(function (column) { return column; });

// 		// create a row for each object in the data
// 		var rows = tbody.selectAll('tr')
// 		  .data(data)
// 		  .enter()
// 		  .append('tr');

// 		// create a cell in each row for each column
// 		var cells = rows.selectAll('td')
// 		  .data(function (row) {
// 		    return columns.map(function (column) {
// 		      return {column: column, value: row[column]};
// 		    });
// 		  })
// 		  .enter()
// 		  .append('td')
// 		    .text(function (d) { return d.value; });

// 	  return table;
	}
 
export const updateTabulate = (selection, props) => {
  	const { 
      data, 
      columns,
      onTableRowMouseOver
    } = props;
  	
  // console.log(data);
		// var table = d3.select('#grid table');
		var	tbody = d3.select('#grid table').select('tbody');

  // console.log(tbody.selectAll('tr'))
		// create a row for each object in the data
		var rows = tbody.selectAll('tr').data(data);
  
  //https://stackoverflow.com/questions/32871044/how-to-update-d3-table
    rows.selectAll('td')
		  .data(function (row) {
		    return columns.map(function (column) {
		      return {column: column, value: row[column]};
		    });
		  })
    	.text(d => d.value);
  		
  // rows.exit().remove();
  	var rowsEnter = rows
    	.enter()
    		.append('tr')
    		// .on('mouseEnter', onTableRowMouseOver)
    		// .on('mouseLeave', );
  	// console.log(rows);
  	rows.exit().remove();
		// create a cell in each row for each column
		var cells = rowsEnter.selectAll('td')
		  .data(function (row) {
		    return columns.map(function (column) {
		      return {column: column, value: row[column]};
		    });
		  })
    	.enter()
    		.append('td')
    		.text(d => d.value);
		
	  // return table;
	}